hdu 1960 Bus System

Bus System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 6166    Accepted Submission(s): 1580

Problem Description

Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it’s still playing an important role even now.
The bus system of City X is quite strange. Unlike other city’s system, the cost of ticket is calculated based on the distance between the two stations. Here is a list which describes the relationship between the distance and the cost.

Your neighbor is a person who is a really miser. He asked you to help him to calculate the minimum cost between the two stations he listed. Can you solve this problem for him?
To simplify this problem, you can assume that all the stations are located on a straight line. We use x-coordinates to describe the stations’ positions.

Input

The input consists of several test cases. There is a single number above all, the number of cases. There are no more than 20 cases.
Each case contains eight integers on the first line, which are L1, L2, L3, L4, C1, C2, C3, C4, each number is non-negative and not larger than 1,000,000,000. You can also assume that L1<=L2<=L3<=L4.
Two integers, n and m, are given next, representing the number of the stations and questions. Each of the next n lines contains one integer, representing the x-coordinate of the ith station. Each of the next m lines contains two integers, representing the start point and the destination.
In all of the questions, the start point will be different from the destination.
For each case,2<=N<=100,0<=M<=500, each x-coordinate is between -1,000,000,000 and 1,000,000,000, and no two x-coordinates will have the same value.

Output

For each question, if the two stations are attainable, print the minimum cost between them. Otherwise, print “Station X and station Y are not attainable.” Use the format in the sample.

Sample Input

2
1 2 3 4 1 3 5 7
4 2
1
2
3
4
1 4
4 1
1 2 3 4 1 3 5 7
4 1
1
2
3
10
1 4

Sample Output

Case 1:
The minimum cost between station 1 and station 4 is 3.
The minimum cost between station 4 and station 1 is 3.
Case 2:
Station 1 and station 4 are not attainable.

题意:坐公交车不同的距离,所需要的花费是不一样的,给你8个数,前4个代表不同的距离,后4个代表的是相应的花费,若距离不在所规定的范围,则不能到达吧。再输入n和m,分别表示在坐标上有n个点,代表不同的坐标值,m则代表将要询问的最短路的次数了。

解题思路:就是一道dijkstra或floyd的模板题,但要注意数据的大小,要用int64位来计算,而且定义的最大值的是非常大的数。一开始我定义为2^32-1,但结果WA了,后面改了就可以了。

Dijkstra贴代码:

#include <stdio.h>
#define maxn 1e18

__int64 map[105][105], dis[105];
int visited[105];

void Dijkstra(int start, int n)
{
    __int64 mind;
    int pre = start;
    for(int i = 1; i<=n; i++)
    {
        dis[i] = map[start][i];
        visited[i] = 0;
    }
    visited[start] = 1;
    for(int i = 1; i<=n; i++)
    {
        mind = maxn;
        for(int j = 1; j<=n; j++)
        {
            if(!visited[j] && mind > dis[j])
            {
                mind = dis[j];
                pre = j;
            }
        }
        visited[pre] = 1;
        for(int j = 1; j<=n; j++)
        {
            if(!visited[j] && dis[j] > dis[pre]+map[pre][j])
                dis[j] = dis[pre]+map[pre][j];
        }
    }
}

int main()
{
    __int64 x, N[105];
    int t = 1, T;
    int n, m;
    int start, finish;
    __int64 L1, L2, L3, L4, C1, C2, C3, C4;
    scanf("%d", &T);
    while(T--)
    {
        scanf("%I64d%I64d%I64d%I64d%I64d%I64d%I64d%I64d", &L1, &L2, &L3, &L4, &C1, &C2, &C3, &C4);
        scanf("%d%d", &n, &m);
        for(int i = 1; i<=n; i++)
            scanf("%I64d", &N[i]);

        for(int i = 1; i<=n; i++)
        {
            for(int j = 1; j<=n; j++)
            {
                if(N[i] > N[j])
                    x = N[i] - N[j];
                else
                    x = N[j] - N[i];
                if(x>0 && x<=L1)
                    map[i][j] = C1;
                else if(x>L1 && x<=L2)
                    map[i][j] = C2;
                else if(x>L2 && x<=L3)
                    map[i][j] = C3;
                else if(x>L3 && x<=L4)
                    map[i][j] = C4;
                else
                    map[i][j] = maxn;
                if(i == j)
                    map[i][j] = 0;
            }
        }
        printf("Case %d:\n", t++);
        while(m--)
        {
            scanf("%d%d", &start, &finish);
            Dijkstra(start, n);

            if(visited[finish])
                printf("The minimum cost between station %d and station %d is %I64d.\n", start, finish, dis[finish]);
            else
                printf("Station %d and station %d are not attainable.\n", start, finish);
        }
    }

    return 0;
}

Floyd算法的代码:

#include <stdio.h>
#define maxn 1e18

__int64 map[105][105], dis[105];

void Floyd(int n)
{
    for(int k = 1; k<=n; k++)
    {
        for(int i = 1; i<=n; i++)
        {
            for(int j = 1; j<=n; j++)
            {
                if(map[i][j] > map[i][k]+map[k][j])
                    map[i][j] = map[i][k]+map[k][j];
            }
        }
    }
}

int main()
{
    __int64 x, N[105];
    int t = 1, T;
    int n, m;
    int start, finish;
    __int64 L1, L2, L3, L4, C1, C2, C3, C4;
    scanf("%d", &T);
    while(T--)
    {
        scanf("%I64d%I64d%I64d%I64d%I64d%I64d%I64d%I64d", &L1, &L2, &L3, &L4, &C1, &C2, &C3, &C4);
        scanf("%d%d", &n, &m);
        for(int i = 1; i<=n; i++)
            scanf("%I64d", &N[i]);

        for(int i = 1; i<=n; i++)
        {
            for(int j = 1; j<=n; j++)
            {
                if(N[i] > N[j])
                    x = N[i] - N[j];
                else
                    x = N[j] - N[i];
                if(x>0 && x<=L1)
                    map[i][j] = C1;
                else if(x>L1 && x<=L2)
                    map[i][j] = C2;
                else if(x>L2 && x<=L3)
                    map[i][j] = C3;
                else if(x>L3 && x<=L4)
                    map[i][j] = C4;
                else
                    map[i][j] = maxn;
                if(i == j)
                    map[i][j] = 0;
            }
        }
        Floyd(n);
        printf("Case %d:\n", t++);
        while(m--)
        {
            scanf("%d%d", &start, &finish);

            if(map[start][finish] != maxn)
                printf("The minimum cost between station %d and station %d is %I64d.\n", start, finish, map[start][finish]);
            else
                printf("Station %d and station %d are not attainable.\n", start, finish);
        }
    }

    return 0;
}

hdu 1960 Bus System

时间: 2025-01-22 21:33:16

hdu 1960 Bus System的相关文章

hdu 1690 Bus System (最短路径)

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6082    Accepted Submission(s): 1560 Problem Description Because of the huge population of China, public transportation is very importa

hdu 1690 Bus System(Floyd)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Problem Description Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it's

hdu 1690 Bus System(Dijkstra最短路)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6569    Accepted Submission(s): 1692 Problem Description Because of the huge popula

hdu 1690 Bus System(最短路)

问题: 链接:点击打开链接 题意: 思路: 代码: #include <iostream> #include <cstdio> #include <cstring> using namespace std; #define INF 1000000000000 typedef __int64 LL; const int N = 110; __int64 dis[N][N],place[N]; __int64 L1,L2,L3,L4,C1,C2,C3,C4; int n,m

hdu 1690 Bus System 最短路 Floyd算法。。INF一定要很大很大。。。数据类型用long long。

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 7163    Accepted Submission(s): 1853 Problem Description Because of the huge population of China, public transportation is very import

HDU 1690 Bus System 任意点最短路径Floyd

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1690 题目大意: 图中的表是代表不同长度路径的花费,输入所有点的坐标,求任意两点间的最短花费. 因为是求任意两点,这里最好是用floyd算法. 题中几大坑: 数据可能会超int,要用long long int: 坐标可以为负,求距离要用abs绝对值函数. 参考代码如下: #include <iostream> #include"iostream" #include"st

hdu 1690 Bus System

floyd算法.这题目比较操蛋,首先INF需要比较大,我选择了INF = 0xffffffffffffff.还有一点就是%lld会挂掉的,用%I64d才能AC. #include<cstdio> #include<cmath> #include<cstring> #include<algorithm> using namespace std; const int maxn = 105; __int64 INF = 0xffffffffffffff; __in

Bus System 【dijkstra算法】

Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it's still playing an important role even now.The bus system of City X is qui

Bus System(Flody)

http://acm.hdu.edu.cn/showproblem.php?pid=1690 坑爹的题,必须用__int64 %I64d(以前没用过) 因为这题的数据特别大,所以用-1 1 #include <iostream> 2 #include <stdio.h> 3 #include <string.h> 4 #include <stdlib.h> 5 #include <math.h> 6 using namespace std; 7